


  OtherMenu Externals Manual
  by James W. Walker
  CIS: 76367,2271
  AOL: JWWalker

  Updated August 11, 1994

Each of the standard OtherMenu externals is documented below, with its current version number.  Remember that if you select an external from the menu with the shift key held down, then you will get a dialog box which shows the version and may allow you to change some settings.




There are three icons for OtherMenu externals, corresponding to their form, all pictured above (if you are reading this document in TeachText, SimpleText, or Tex-Edit).  See the OtherMenu Manual for how to get information on writing your own externals if you are a programmer.  All three types become menu items in OtherMenu, and, for the most part, we will ignore their differences here.


Clip Info 1.1
-------------

This external provides a submenu listing the types of data on the system clipboard, and how much memory they take up.  If there is text on the clipboard, the submenu also gives a word count and line count.  For example, if you copy some styled text to the clipboard, you might see something like:

TEXT: 175 bytes
styl: 22 bytes
----------------
Lines: 4
Words: 21

For the purpose of this count, a word is defined to be any string of characters other than space, option-space, return, or tab.

Some applications have private clipboards, which may have different contents from the system clipboard.  Switching from one application to another should bring the clipboards into sync.


Copy File  1.2.4
-----------------
First you choose a file, then you can save it elsewhere, with another name if you like.  The bottom of the save dialog shows the size of the file and the amount of free space on the disk.  A copy in progress can be cancelled by typing command-period or escape.

If you save over an existing file, you will see an alert asking you to confirm the action and letting you know how the modification dates compare.  Specifically, if the file you are saving is newer than the existing file, the alert will say Replace older <filename>?, and if the file you are saving is older (a less likely situation) the alert will say Replace NEWER <filename>?.  If the dates are the same, the alert will be the familiar Replace existing <filename>?.  File replacements will be done by a fail-safe method, so long as there is enough disk space to do so.  That is, the copy will be created in a temporary location, and only when it is complete will the old copy be deleted and replaced by the copy.


Date/Time 1.3
-------------
Displays a submenu showing the date and the time in several formats.  Selecting one pastes it into the current document.  You can specify a prefix or suffix, e.g. you might want to append  CDT after the time.

The formats available are affected by Apples _Date_&_Time_ control panel.


Delete... 1.2.1
-------------
Delete a file or empty folder.  If you want to delete a folder full of files, you can use Move to Trash and Empty Trash instead.  Normally, you will see an alert saying something like Are you sure you want to delete <filename>?.  You can turn off this confirmation, using the configuration dialog, but be careful; deleting a file cannot be undone.  You can also control whether or not locked files should be deleted anyway.


Desktop Info... 1.3.3
---------------------
Utility for poking around in the desktop database.  This may not be useful for anyone but programmers.  It shows what icons and sizes are associated with a given creator code.  You may sometimes see the word paul in place of an icon; this item stores information related to drag-and-drop.


Empty Trash 1.0.2
-----------------
Like selecting Empty Trash in the Finder, except that you dont get a dialog asking if youre sure.


File Info... 1.3.1
------------------
Get some information about a file such as data and size, and show or change attributes such as type and creator.  In the case of applications, it can alter the memory partition size.

If a file is locked, then an application cannot open it for write access without first unlocking it.  The name locked attribute prevents one from using the Finder to rename the file or give it a custom icon.  The invisible attribute makes the file invisible to the Finder, but not necessarily to directory dialogs like the File Info dialog.  The has BNDL attribute, sometimes called the bundle bit, indicates a file that owns an icon family; usually applications, control panels, and extensions have this attribute, and ordinary documents do not.


Hard to Soft Wrap 1.3.1
-----------------------
Edits text on the clipboard by replacing any isolated carriage return with a space.  Multiple carriage returns are left alone. A carriage return at the very beginning or end is deleted. Since this does not do anything immediately visible, it plays a sound when it completes successfully.

This is not a true external, but a special little application.  I made it an application to fix some clipboard conversion problems.  Since it is an application, you cannot invoke it while a modal dialog is on screen, unlike normal externals.

The application is actually a shell containing a Clipboard Magician conversion resource (CNVT and CNV!).  If you have Clipboard Magician, you could duplicate the shell and use the Magic Wand Utility to move a different conversion resource into it.  


Make Alias As... 1.3.4
----------------------
Make an alias for a file, folder, or volume, and put it where you like.  This is very useful for setting up your OtherMenu Folder.


Memory Map 1.4.3
----------------
Find out how much memory each application is using, and how much is left.  When you dont have enough free memory to launch another application, this will help you understand why, and let you see which applications you could quit to make room for a new one.  You can also select applications and tell them to quit.

When you quit applications, they will usually quit within a few seconds, and the list will update to show the new free memory.  However, if you quit the foreground application, or an application that does not understand AppleEvents, then it may not quit until after you close the Memory Info window.  Also be aware that an application that has unsaved data will probably want to ask you whether to save it before it quits.

Optionally, the map displays locked blocks of temporary memory as well as applications.  There are many small ones (less than 1K) associated with launching any application, so I would suggest not displaying the small ones to avoid cluttering the list.  Only a few applications create larger blocks of temporary memory.

Clicking the Settings button brings up the settings dialog, so that you can more easily change the temporary memory setting.


Monitor Depth 1.1
-----------------
Set the color depth of the monitor, using a submenu.  If there is more than one monitor, it controls the one with the greatest depth.  If two have the same depth, I'm not sure what happens.  Obviously, if your Mac does not support color or gray-scale, you can trash this.

Changes in depth made by this external are forgotten when you restart your Mac, unlike the Monitors control panel.


Move to Trash... 2.0.3
----------------------
Move selected files or folders to the trash.  The Add button moves a selected item from the main list to the lower list of items to be trashed, and the Done button tells the Finder to trash the selected items.


Move/Rename... 1.2.2
--------------------
Move or rename something.  One can only move something within a volume, as in Finder.


New Folder... 1.0.1
-------------------
Take a wild guess.  Since many save dialogs have a New Folder button, this external is not very essential.


Open... 1.1.3
-------------
Selecting something (file or folder) with this is rather like selecting it in Finder and then selecting Open from the Finder menu.  In some cases, especially when Finder is not running, this may be able to launch something when OtherMenu itself cannot.


Paste Clip 1.0
--------------
Using its settings dialog, you can specify a frequently-used piece of text, such as an address (no more than 255 characters.)  When the external is invoked normally, it pastes this text into the current application.  Since the return character can be entered as part of the text, there is no default button, and you must use the mouse to click OK.


Paste Clips 1.2
---------------
Stores several frequently-used scraps of text, and displays a submenu so that you can select one to be pasted into a document.  You give each clipping a short label, which identifies it in the menu.  The configuration dialog lets you add, delete, modify, or reorder the clippings.  The New and Delete buttons should be fairly obvious, but you might not guess that you can rearrange the list by dragging a cell of the list and dropping it in a different position.

The label can be up to 20 characters long, and the clipping can be up to 1024 characters long.  If the label begins with a hyphen, the item will appear as a dividing line in the menu.


Put Away... 1.2.9
-----------------
Put items in the trash or on the desktop back where they came from.  Also unmounts disks.  The Finder needs to be running to do a normal put away, but not to unmount a disk.

You can shift-click to make contiguous multiple selections, or command-click to make arbitrary multiple selections.  A double click on a list acts as a shortcut for a click on a list followed by a click on the OK button.

One of the two lists has an extra frame, indicating that it is the target of keyboard commands.  You can select an item using the up and down arrow keys, or by typing a few letters of a name.  You can scroll the list using the page up, page down, home, and end keys if your keyboard has those keys.  The tab key switches to the other list.


QuickAlias 1.0.1
----------------

This external may be more convenient than Make Alias As if you will be making many aliases in the same place, as when you are setting up your Other menu or your Apple menu.  When you run this external, it displays a dialog showing a path to a folder.  If it is not the folder in which you want to create some aliases, click the Set Folder button and select a new folder.  As long as QuickAlias is running, any item that you select from the Other menu will be aliased into the chosen folder.  When an alias is created, a little sound is played to reassure you that something happened.

You might find it convenient to make several copies of QuickAlias, set to different folders.


QuickTrash 1.0
-------------

This external can be used as an alternative to Move to Trash for trashing multiple items.  When the external is running, any item you select from the Other menu will be moved to the trash.  If you select an alias, then the alias will be moved rather than the original item, just as in the Finder.  When an item is trashed, a little sound is played to reassure you that something happened.

If you try to trash something when the trash already contains an item of the same name, QuickTrash may ask Finder for help.  So in this case if Finder is not running, it will not work, and if QuickTrash is running within Finder, then the action will not be completed until you dismiss QuickTrash.


Quit Finder 1.2.1
-----------------
Tells the Finder to quit.  If file sharing is turned on, it will be turned off just before Finder.

Actually, you can use this to make any other single application quit, by using its configuration dialog to specify the creator code of an application.  But youd only do that for something you quit very often, since Memory Map would otherwise be a more convenient way to quit something.


Quote 1.0
---------

This external transforms text on the clipboard for BBS quoting.  The way you would use it is to copy some text to the clipboard, invoke the Quote external, and then paste, perhaps into a different application.  If you invoke Quote with the option key held down, you will be able to set various options:  Whether to break lines so that they are not too long, a prefix string to be added to the beginning of each line, and whether to replace curly quotes by straight quotes.

You might want to make several copies of Quote, with different settings.  If you turn on Rewrap lines, set the maximum line length to 0, and set the prefix string to the empty string, then Quote behaves almost exactly like Hard to Soft Wrap.  On the other hand, by specifying a positive maximum line length you can use Quote to hard-wrap text.


Restart 1.0.2
-------------
Like the Restart command in Finder.  In fact it works by telling Finder to do a restart.


Shut Down 1.0.1
---------------
Like the Shut Down command in Finder.  In fact it works by telling Finder to do a shutdown.


Sleep 1.0
---------
Like selecting Sleep in the Finder.  Of course this only works on those models that have a sleep mode.  Finder must be running, but need not be in the foreground.


Speaker Volume 1.1.1
--------------------
Provides a submenu for setting the speaker volume.


Volume Info 1.2.5
-----------------
Shows the icon, name, free space, and number of files on each mounted volume.


Windows 1.2.2
-------------
Provides a submenu of windows in the current application.  Selecting one brings it to the front, unless the front window is a modal dialog.  Not to be confused with a DOS enhancement of the same name.


Memory Usage
-------------
Shows how much system memory OtherMenu is using, and how many menus are cached.  This is actually not a true external, the code it runs is in OtherMenu itself.
